--****************************************************************************
--**
--**  File     :  /lua/shield.lua
--**  Author(s):  John Comes, Gordon Duclos
--**
--**  Summary  : Shield lua module
--**
--**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
--****************************************************************************

local oldShield = Shield
Shield = Class(oldShield) {

    InitBuffValues = function(self,spec)
        self.spec = spec
        spec.Owner.Sync.ShieldMaxHp = spec.ShieldMaxHealth -- replace this with generic
        spec.Owner.Sync.ShieldRegen = spec.ShieldRegenRate -- method to directly query
        --LOG(spec.ShieldRegenRate)
        --LOG(self.XPperDamage)
    end,

    OnCreate = function(self,spec)
        self:InitBuffValues(spec)
        oldShield.OnCreate(self,spec)
        if EntityCategoryContains(categories.STRUCTURE - categories.UNSELECTABLE -categories.UNTARGETABLE - categories.INSIGNIFICANTUNIT , self.Owner) and self.Owner.XPnextLevel then
            self.XPonDamaged = ForkThread(self.XPonDamagedThread, self)
        end
    end,

    ChargingUp = function(self, curProgress, time)
        oldShield.ChargingUp(self, curProgress, time)
        self:SetHealth(self,self:GetMaxHealth())
    end,

    XPonDamagedThread = function(self)
        while not self.Owner:IsDead() do
            if self:GetHealth() < self:GetMaxHealth() then
                self.Owner:AddXP(self.Owner.XPnextLevel* 0.04)
            end
            WaitTicks(40)
        end
    end,

}

local oldUnitShield = UnitShield
UnitShield = Class(oldUnitShield){

    OnCreate = function(self,spec)
        Shield.InitBuffValues(self,spec)
        oldUnitShield.OnCreate(self,spec)
        if EntityCategoryContains(categories.MOBILE * categories.SHIELD * categories.DEFENSE - categories.UNSELECTABLE - categories.UNTARGETABLE - categories.INSIGNIFICANTUNIT , self.Owner) and self.Owner.XPnextLevel then
            self.XPonDamaged = ForkThread(self.XPonDamagedThread, self)
        end
    end,

    ChargingUp = function(self, curProgress, time)
        oldUnitShield.ChargingUp(self, curProgress, time)
        self:SetHealth(self,self:GetMaxHealth())
    end,


}

