--****************************************************************************
--**
--**  File     :  /lua/sim/buffdefinition.lua
--**
--**  Copyright  2008 Gas Powered Games, Inc.  All rights reserved.
--****************************************************************************

import('/lua/sim/AdjacencyBuffs.lua')
import('/lua/sim/CheatBuffs.lua') -- Buffs for AI Cheating

------------------------------------------------------------------------------------------------------------------------------------
---- VETERANCY BUFFS - UNIT HEALTH
------------------------------------------------------------------------------------------------------------------------------------

BuffBlueprint {
    Name = 'VeterancyHealth',
    DisplayName = 'VeterancyHealth',
    BuffType = 'VETERANCYHEALTH',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        MaxHealth = {
            Add = 0,
            Mult = 1.1,
        },
    },
}

------------------------------------------------------------------------------------------------------------------------------------
---- VETERANCY BUFFS - UNIT REGEN
------------------------------------------------------------------------------------------------------------------------------------

BuffBlueprint {
    Name = 'VeterancyRegen',
    DisplayName = 'VeterancyRegen',
    BuffType = 'VETERANCYREGEN',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        Regen = {
            Add = 0,
            Mult = 1.1,
        },
    },
}

------------------------------------------------------------------------------------------------------------------------------------
---- VETERANCY BUFFS - UNIT DAMAGE
------------------------------------------------------------------------------------------------------------------------------------

BuffBlueprint {
    Name = 'VeterancyDamage',
    DisplayName = 'VeterancyDamage',
    BuffType = 'VETERANCYDAMAGE',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        Damage = {
            Add = 0,
            Mult = 1.10,--was 1.05, changed to see if this affects speed
        },
    },
}

------------------------------------------------------------------------------------------------------------------------------------
---- VETERANCY BUFFS - UNIT DAMAGE AOE
------------------------------------------------------------------------------------------------------------------------------------

BuffBlueprint {
    MaxLevel = 20,
    Name = 'VeterancyDamageArea',
    DisplayName = 'VeterancyDamageArea',
    BuffType = 'VETERANCYDAMAGEAREA',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        DamageRadius = {
            Add = 0,
            Mult = 1.05,
        },
    },
}

------------------------------------------------------------------------------------------------------------------------------------
---- VETERANCY BUFFS - UNIT Weapon Range
------------------------------------------------------------------------------------------------------------------------------------

BuffBlueprint {
    MaxLevel = 100,--was 40
    Name = 'VeterancyRange',
    DisplayName = 'VeterancyRange',
    BuffType = 'VETERANCYRANGE',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        MaxRadius = {
            Add = 0,
            Mult = 1.01,--was .025
        },
    },
}

------------------------------------------------------------------------------------------------------------------------------------
---- VETERANCY BUFFS - UNIT Weapon Range
------------------------------------------------------------------------------------------------------------------------------------

BuffBlueprint {
    MaxLevel = 100, --was 20
    Name = 'VeterancySpeed',
    DisplayName = 'VeterancySpeed',
    BuffType = 'VETERANCYSPEED',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        MoveMult = {
            Add = 0,
            Mult = 1.01, --was .025
        },
    },
}


--gh, see if we can re-enable this
BuffBlueprint {
    Name = 'VeterancyFuel',
    DisplayName = 'VeterancyFuel',
    BuffType = 'VETERANCYFUEL',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        Fuel = {
            Add = 0,
            Mult = 1.05,
        },
    },
}

BuffBlueprint {
    Name = 'VeterancyShield',
    DisplayName = 'VeterancyShield',
    BuffType = 'VETERANCYSHIELD',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        ShieldHP = {
            Add = 0,
            Mult = 1.1,
        },
        ShieldRegen = {
            Add = 0,
            Mult = 1.1,
        },
    },
}

BuffBlueprint {
    MaxLevel = 40,
    Name = 'VeterancyVision',
    DisplayName = 'VeterancyVision',
    BuffType = 'VETERANCYVISION',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        VisionRadius = {
            Add = 0,
            Mult = 1.025,
        },
    },
}

BuffBlueprint {
    MaxLevel = 40,
    Name = 'VeterancyOmniRadius',
    DisplayName = 'VeterancyOmniRadius',
    BuffType = 'VETERANCYOMNIRADIUS',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        OmniRadius = {
            Add = 0,
            Mult = 1.025,
        },
    },
}

BuffBlueprint {
    MaxLevel = 40,
    Name = 'VeterancyRadar',
    DisplayName = 'VeterancyRadar',
    BuffType = 'VETERANCYRADAR',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        RadarRadius = {
            Add = 0,
            Mult = 1.025,
        },
    },
}
--gh, sonar buff
BuffBlueprint {
    MaxLevel = 40,
    Name = 'VeterancySonar',
    DisplayName = 'VeterancySonar',
    BuffType = 'VETERANCYSONAR',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        SonarRadius = {
            Add = 0,
            Mult = 1.025,
        },
    },
}

BuffBlueprint {
    Name = 'VeterancyBuildRate',
    DisplayName = 'VeterancyBuildRate',
    BuffType = 'VETERANCYBUILDRATE',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        BuildRate = {
            Add = 0,
            Mult = 1.1,
        },
    },
}

BuffBlueprint {
    Name = 'VeterancyResourceProduction',
    DisplayName = 'VeterancyResourceProduction',
    BuffType = 'VeterancyResourceProduction',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        EnergyProductionBuf = {
            Add = 0,
            Mult = 1.2,
        },
        MassProductionBuf = {
            Add = 0,
            Mult = 1.1,
        },
    },
}

BuffBlueprint {
    Name = 'VeterancyRateOfFire',
    DisplayName = 'VeterancyRateOfFire',
    BuffType = 'VETERANCYRATEOFFIRE',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        RateOfFireBuf = {
            Add = 0,
            Mult = 1.01, --was 1.05, test to see if it is worth removing for speed
        },
    },
}

--gh, commander specific buff, much less hassle, really ...
BuffBlueprint {
    Name = 'VeterancyCommandProduction',
    DisplayName = 'VeterancyCommandProduction',
    BuffType = 'VETERANCYCOMMANDPRODUCTION',
    Stacks = 'ALWAYS',
    Duration = -1,
    MaxLevel = 10,
    Affects = {
        EnergyProductionBuf = {
            Add = 100, --was 200
            Mult = 1,
        },
        MassProductionBuf = {
            Add = 1, -- was 2
            Mult = 1,
        },
    },
}
BuffBlueprint {
    MinLevel = 40,
    MaxLevel = 940,
    Name = 'VeterancySpeed2',
    DisplayName = 'VeterancySpeed2',
    BuffType = 'VETERANCYSPEED2',
    Stacks = 'ALWAYS',
    Duration = -1,
    Affects = {
        MoveMult = {
            Add = 0,
            Mult = 1.01, --was .025
        },
    },
}

--BuffBlueprint { -- no way to manipulate blueprint values runtime save for the given engine functions except weapons, apparently
--    Name = 'VeterancyBuildRange',
--    DisplayName = 'VeterancyBuildRange',
--    BuffType = 'VETERANCYBUILDRANGE',
--    Stacks = 'ALWAYS',
--    Duration = -1,
--    Affects = {
--        BuildRange = {
--            Add = 10,
--            Mult = 1.1,
--        },
--    },
--}




__moduleinfo.auto_reload = true
